//*****************************************************************************
//  SpoutEX Main File
//  Ver 1.0
//
//  Copyright (C) Alekmaul. All rights reserved.
//       http://www.portabledev.com
//  Originale version http://www.din.or.jp/~ku_
//******************************************************************************
#include "./s2d/s2d.h"
using namespace s2d;

/*#include <stdio.h>
#include <stdlib.h>
#include <string.h>*/

#include "spoutex.h"
#include "piece.h"
#include "font.h"

//******************************************************************************

unsigned char *vBuffer = NULL;

unsigned short pltTbl[20] = { 
  RGB_565(255,255,255),  // Normal colors
  RGB_565(168,168,168),
  RGB_565( 96, 96, 96),
  RGB_565(  0,  0,  0),

  RGB_565(28*8,30*8, 9*8),  // Spout colors
  RGB_565(30*8,25*8, 9*8),
  RGB_565(30*8,17*8, 9*8),
  RGB_565(20*8, 0, 0),

  RGB_565(12*8,12*8,12*8), // Wall color #1
  RGB_565(21*8,21*8,0), // Wall color #2
  RGB_565(12*8,12*8,0), // Wall color #3
  RGB_565(255,  0,255), // Wall color #4
  RGB_565(168,  0,168), // Wall color #5
  RGB_565( 96,  0, 96), // Wall color #6
  RGB_565(  0,255,255), // Wall color #7
  RGB_565(  0,168,168), // Wall color #8
  RGB_565(  0, 96, 96), // Wall color #9
};

u8 *pceLCDSetBuffer(u8 *pbuff) {
  if(pbuff) {
    vBuffer = pbuff;
  }
  return vBuffer;
}

int font_posX = 0, font_posY = 0, font_width = 4, font_height = 6;
unsigned char font_fgcolor = 3, font_bgcolor = 0, font_bgclear = 0;
unsigned char *font_adr = (unsigned char *) FONT6;

void pceFontSetType(int type) {
  const int width[] = {5, 8, 4};
  const int height[] = {10, 16, 6};
  unsigned char *adr[] ={FONT6, FONT16, FONT6};

  type &= 3;
  font_width = width[type];
  font_height = height[type];
  font_adr = adr[type];
}

void pceFontSetTxColor(int color) {
  font_fgcolor = (u8) color;
}

void pceFontSetBkColor(int color) {
  if(color >= 0) {
    font_bgcolor = (u8) color;
    font_bgclear = 0;
  } else {
    font_bgclear = 1;
  }
}

void pceFontSetPos(int x, int y) {
  font_posX = x;
  font_posY = y;
}

int pceFontPrintf(char const *fmt) {
  u8 *adr = vBuffer + font_posX + font_posY * SPEX_WIDTH;
  char *pC;
  int i, x, y;
  u8 *sAdr;

  pC = (char *) fmt;
  while(*pC) {
    if(*pC >= 0x20 && *pC < 0x80) {
      i = *pC - 0x20;
    } else {
      i = 0;
    }
    sAdr = font_adr + (i & 15) + (i >> 4) * 16 * 16;
    for(y = 0; y < font_height; y ++) {
      u8 c = *sAdr;
      for(x = 0; x < font_width; x ++) {
        if(c & 0x80) {
          *adr = font_fgcolor;
        } else if(font_bgclear == 0) {
          *adr = font_bgcolor;
        }
        adr ++;
        c <<= 1;
      }
      adr += SPEX_WIDTH - font_width;
      sAdr += 16;
    }
    adr -= SPEX_WIDTH * font_height - font_width;
    pC ++;
  }
  return 1;
}
